# bugtraq.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# this script post  every  new vulnerability from  the bugtraq mailing  list to
# certain channels and posts the last X vulnerabilitys to a user using a public
# or message command. 
# also there is the usual hub function included.
#
# v1.0 - first public version
#
# bugtraqtrigger - the trigger the bot respons to (public and message)
# bugtraqchans - the chans the script is active in, "" for all
# bugtraqlimit - the maximum number of news the bot posts (on cmd)
# bugtraqnewspostlimit - the maximum  news the bot posts (newsposting)
# bugtraqnewspost - 1 enables newsposting, 0 disables it
# isbugtraqhub - 1 enables the hub function, 0 disables it
# bugtraqleafs - the bots the leaf tcl is running on
#
####### config ######################

set bugtraqtrigger ".bugtraq"
set bugtraqchans ""
set bugtraqlimit "5"
set bugtraqnewspostlimit "3"
set bugtraqnewspost "1"
set isbugtraqhub "1"
set bugtraqleafs ""

####### end of config ###############

bind msg - $bugtraqtrigger msg_bugtraq
bind pub - $bugtraqtrigger pub_bugtraq
bind time - "?0 * * * *" bugtraqcheck


proc sendbugtraqnews { arg } {
global bugtraqleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $bugtraqleafs] [string tolower $bot]]
!= -1)} {
putbot $bot "bugtraq: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc bugtraqnews { target limit } {
if {[catch {set sock [socket online.securityfocus.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /bid HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: online.securityfocus.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "CLASS=\"bulletlink\" HREF=\"/bid" $bl] != -1} {
set link "http://online.securityfocus.com[string range $bl [shrink + 7 " HREF=\"" 0 $bl] [shrink - 1 "\">" 40 $bl]]"
set newsline [string range $bl [shrink + 2 "\">" 40 $bl] [shrink - 1 "</A>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc bugtraqcheck {nick uhost hand chan arg} {
global bugtraqchans bugtraqnewspost isbugtraqhub bugtraqnewspostlimit
set counter 0
if {$bugtraqnewspost == 1 } {
putlog "bugtraq: suche nach neuer newsline"
set bugtraqlastnews "none"
if {[file exists bugtraq.hdl]} {
set temp [open "bugtraq.hdl" r]
set bugtraqlastnews "[gets $temp]"
if {$bugtraqlastnews == ""} { set bugtraqlastnews "none" }
close $temp
}
set temp [open "bugtraq.hdl" w+]
if {[catch {set sock [socket online.securityfocus.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /bid HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: online.securityfocus.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "CLASS=\"bulletlink\" HREF=\"/bid" $bl] != -1} {
set link "http://online.securityfocus.com[string range $bl [shrink + 7 " HREF=\"" 0 $bl] [shrink - 1 "\">" 40 $bl]]"
set newsline [string range $bl [shrink + 2 "\">" 40 $bl] [shrink - 1 "</A>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$bugtraqlastnews == "none" } { putlog "bugtraq: headlinefile created" ; return 0 }
set temp [open "bugtraq.hdl" r]
while { [eof $temp] != 1 } {
set bugtraqneunews [gets $temp]
if {($bugtraqlastnews == $bugtraqneunews) || ($counter == $bugtraqnewspostlimit) || ($bugtraqneunews == "")} { close $temp;return 0 }
incr counter
if { $isbugtraqhub == 1 } {sendbugtraqnews $bugtraqneunews}
foreach chan [channels] {
if {$bugtraqchans == "" } { putserv "privmsg $chan :(new vulnerability) $bugtraqneunews" }
if {$bugtraqchans != "" } {
if {([lsearch -exact [string tolower $bugtraqchans] [string tolower $chan]] != -1) || ($bugtraqchans == "")} {putserv "privmsg $chan :(new vulnerability) $bugtraqneunews"}

}
}}}}


proc msg_bugtraq { nick uhost hand arg } { global bugtraqlimit ; bugtraqnews $nick $bugtraqlimit }
proc pub_bugtraq { nick uhost hand chan arg } { global bugtraqchans bugtraqlimit ; if {([lsearch -exact [string tolower $bugtraqchans] [string tolower $chan]] != -1) || ($bugtraqchans == "")} { bugtraqnews $nick $bugtraqlimit }}


putlog "*** bugtraq.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
